# Copyright 2009-2010 by Ka-Ping Yee
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from utils import *
from html import *

class Dump(Handler):
    def get(self):
        self.write('''
<!doctype html public "-//W3C//HTML 4.01 Transitional//EN">
<link rel=stylesheet href="static/style.css">
''')
        country_codes = [country.key().name() for country in Country.all()]
        if self.request.get('cc'):
            country_codes = [self.request.get('cc')]
        for cc in sorted(country_codes):
            version = get_latest_version(cc)
            self.write_version(version)
            if version and version.base:
                self.write_version(get_base(version))

    def write_version(self, version):
        self.write('<p><dl><dt>' + html_repr(version))
        if version:
            for entity in db.Query().ancestor(version):
                self.write('<dd>' + html_repr(entity, leaf=1))
        self.write('</dl>')

if __name__ == '__main__':
    run([('/dump', Dump)], debug=True)
