# Copyright 2009-2010 by Ka-Ping Yee
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from utils import *
import access
import rendering

class Main(Handler):
    def get(self):
        auth = access.check_and_log(self.request, users.get_current_user())
        if auth:
            self.render('templates/map.html',
                authorization=auth.description,
                logout_url=users.create_logout_url('/'),
                data=rendering.version_to_json(get_latest_version('tz')),
                instance=self.request.host.split('.')[0])
        else:
            self.redirect(users.create_login_url('/'))

if __name__ == '__main__':
    run([('/', Main)], debug=True)
